<?php
/**
* @version $Id: joomleague.searchbot.php 5055 2008-09-14 16:38:01Z friesengeist $
* @package Joomla
* @copyright Copyright (C) 2005 Open Source Matters. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/

// no direct access
defined( '_VALID_MOS' ) or die( 'Restricted access' );

$_MAMBOTS->registerFunction( 'onSearch', 'botSearchJoomleague' );

/**
* Joomleague Search method
*
* The sql must return the following fields that are used in a common display
* routine: href, title, section, created, text, browsernav
* @param string Target search string
* @param string mathcing option, exact|any|all
* @param string ordering option, newest|oldest|popular|alpha|category
*/
function botSearchJoomleague( $text, $phrase='', $ordering='' ) {
     global $database, $my, $_MAMBOTS;
     global $mosConfig_absolute_path, $mosConfig_lang;

     if (file_exists($mosConfig_absolute_path.'/components/com_joomleague/language/'.$mosConfig_lang.'.php')) {
      include_once($mosConfig_absolute_path.'/components/com_joomleague/language/'.$mosConfig_lang.'.php');
     } else{
      include_once($mosConfig_absolute_path.'/components/com_joomleague/language/english.php');
     }

     // check if param query has previously been processed
     if ( !isset($_MAMBOTS->_search_mambot_params['joomleague']) ) {
    	// load mambot params info
    	$query = "SELECT params"
    	. "\n FROM #__mambots"
    	. "\n WHERE element = 'joomleague.searchbot'"
    	. "\n AND folder = 'search'";
		
    	$database->setQuery( $query );
    	$database->loadObject($mambot);	
    		
    	// save query to class variable
    	$_MAMBOTS->_search_mambot_params['joomleague'] = $mambot;
     }
     
     // pull query data from class variable
     $mambot = $_MAMBOTS->_search_mambot_params['joomleague'];	
     
     $botParams = new mosParameters( $mambot->params );
     
     $limit = $botParams->def( 'search_limit', 50);
     $searchplayers = $botParams->def( 'search_players', 1);
     $searchteams = $botParams->def( 'search_teams', 1);
     $searchevents = $botParams->def( 'search_events', 1);
     $activeproject = $botParams->def( 'use_active_project', 0);
     
     $text = trim( $text );
     if ($text == '') {
     	return array();
     }

     // By JJ. 
     if ($activeproject) {
        $project = mosGetParam($_COOKIE, 'nav_menu_project_id', 0);
        //echo "<br> Project $project<br>";
     }

     /////////////////////////////////////////////////////////////////////
     //                SEARCH PLAYERS
     /////////////////////////////////////////////////////////////////////
     if ($searchplayers) {
	
	$section 	= _JL_PAGE_TITLE_PLAYER;

	$wheres 	= array();
	switch ($phrase) {
		case 'exact':
			$wheres2 = array();

			$wheres2[] = "LOWER(pl.firstname) LIKE '%$text%'";
			$wheres2[] = "LOWER(pl.lastname) LIKE '%$text%'";
			$wheres2[] = "LOWER(pl.info) LIKE '%$text%'";
			$where = '(' . implode( ') OR (', $wheres2 ) . ')';
			break;

		case 'all':
		case 'any':
		default:
			$words 	= explode( ' ', $text );
			$wheres = array();
			foreach ($words as $word) {
				$wheres2 = array();
		  		$wheres2[] 	= "LOWER(pl.firstname) LIKE '%$word%'";
				$wheres2[] 	= "LOWER(pl.lastname) LIKE '%$word%'";
				$wheres2[] 	= "LOWER(pl.info) LIKE '%$word%'";
				$wheres[] 	= implode( ' OR ', $wheres2 );
			}
			$where 	= '(' . implode( ($phrase == 'all' ? ') AND (' : ') OR ('), $wheres ) . ')';
			break;
	}
        

	switch ( $ordering ) {
		case 'oldest':
			$order = 'a.date ASC';
			break;

		case 'popular':
			$order = 'a.hits DESC';
			break;

		case 'alpha':
			$order = 'a.firstname ASC';
			break;

		case 'category':
			$order = 'b.firstname ASC, a.firstname ASC';
			break;

		case 'newest':
		default:
			$order = 'a.date DESC';
	}
       
        // ".$database->Quote(_JL_PLAYERS_KADER_INFO)."
	// 	 ('_JL_PLAYERS_BIRTHDATE_DATE', '%d/%m/%Y');
	//    _JL_PLAYER_BIRTHDAY
	
	// '1' AS browsernav  => open a new window (_blank)
	// '2' AS browsernav  => open in the same window 

      $query = "SELECT 
       CONCAT_WS( ' ', ".$database->Quote(_JL_PLAYER_NAME).", pl.firstname, 
                         pl.lastname, '&nbsp;&nbsp;&#64;&nbsp;&nbsp;',
       ".$database->Quote(_JL_PLAYERS_KADER_INFO).", pl.info, 
       CONVERT(pl.birthday USING utf8),
       '&nbsp;&nbsp;&#64;&nbsp;&nbsp;', ".$database->Quote(_JL_TABLE_TEAM).", t.name) as text,
       CONCAT( pl.firstname , ' ' , pl.lastname)  AS title,
       CONCAT( ' - ',  ". $database->Quote(_JL_PLAYER_PROJECT) ."
	   , ' - ' , pt.project_id, '. ' , p.name) AS created,
       CONCAT(".$database->Quote($section)." ,' / ',pl.firstname) AS section,
       CONCAT('index.php?option=com_joomleague&func=showPlayer&p=', pt.project_id ,'&pid=',pt.id) AS href,
       '1' AS browsernav
            FROM #__joomleague_playertool pt
       LEFT JOIN #__joomleague_players pl ON pl.id = pt.player_id
       LEFT JOIN #__joomleague_teams t ON pt.team_id = t.id
       LEFT JOIN #__joomleague p ON pt.project_id = p.id
       WHERE ($where)";

       if ($activeproject && 
            $project != 0) {
           $query .= sprintf(" AND pt.project_id = %d", $project );
       }

       $database->setQuery( $query, 0, $limit );
       $players = $database->loadObjectList();
	
     } else {
       //echo "<br> No hay busqueda de Jugadores <br>";
      $players = array();
     }

     /////////////////////////////////////////////////////////////////////
     //                SEARCH TEAMS
     /////////////////////////////////////////////////////////////////////
     if ($searchteams) {
	
	   $section 	= _JL_PAGE_TITLE_TEAMINFO;

       $wheres 	= array();
       switch ($phrase) {
		case 'exact':
			$wheres2 = array();

			$wheres2[] = "LOWER(t.name) LIKE '%$text%'";
			$wheres2[] = "LOWER(t.short_name) LIKE '%$text%'";
			$wheres2[] = "LOWER(t.middle_name) LIKE '%$text%'";
			$wheres2[] = "LOWER(tl.description) LIKE '%$text%'";
			$wheres2[] = "LOWER(tl.info) LIKE '%$text%'";
			$where = '(' . implode( ') OR (', $wheres2 ) . ')';
			break;

		case 'all':
		case 'any':
		default:
			$words 	= explode( ' ', $text );
			$wheres = array();
			foreach ($words as $word) {
				$wheres2 = array();
		  		$wheres2[] = "LOWER(t.name) LIKE '%$word%'";
				$wheres2[] = "LOWER(t.short_name) LIKE '%$word%'";
				$wheres2[] = "LOWER(t.middle_name) LIKE '%$word%'";
				$wheres2[] = "LOWER(tl.description) LIKE '%$word%'";
				$wheres2[] = "LOWER(tl.info) LIKE '%$word%'";
				$wheres[] = implode( ' OR ', $wheres2 );
			}
			$where 	= '(' . implode( ($phrase == 'all' ? ') AND 
                                   (' : ') OR ('), $wheres ) . ')';
			break;
       }

        /*
         SELECT tl.* , t.*, u.username
                FROM jos_joomleague_team_joomleague tl
           LEFT JOIN jos_joomleague_teams t on tl.team_id = t.id
           LEFT JOIN jos_users u on tl.admin = u.id
           */

        $query = "SELECT 
             CONCAT_WS( '&nbsp;&nbsp;&#64;&nbsp;&nbsp;' , ".$database->Quote(_JL_TEAMINFO).",
                       t.name, 
                       ".$database->Quote(_JL_TEAMINFO_TEAM_DESC).", 
                       tl.description, tl.info) as text,
             CONCAT_WS( ' ' , tl.team_id, t.name) as title,
             CONCAT(".$database->Quote($section)." 
                      ,' / ',t.short_name) AS section,
             CONCAT( ' - ',  ". $database->Quote(_JL_PLAYER_PROJECT) .",
	             ' - ' , tl.project_id, '. ' , p.name) AS created,
             CONCAT('index.php?option=com_joomleague&func=showTeamInfo&p=', 
                    tl.project_id ,'&tid=',tl.id) AS href,
            '1' AS browsernav
                FROM #__joomleague_team_joomleague tl
           LEFT JOIN #__joomleague_teams t on tl.team_id = t.id
           LEFT JOIN #__joomleague p ON tl.project_id = p.id
           LEFT JOIN #__users u on tl.admin = u.id
           WHERE ($where)";

        if ($activeproject && 
            $project != 0) {
           $query .= sprintf(" AND tl.project_id = %d", $project );
        }
	
        $database->setQuery( $query, 0, $limit );
        $teams = $database->loadObjectList();

     } else {
       //echo "<br> No hay busqueda de Equipos <br>";
      $teams = array();
     }

     /////////////////////////////////////////////////////////////////////
     //                SEARCH EVENTS
     /////////////////////////////////////////////////////////////////////
     if ($searchevents) {
	
    	$section 	= _JL_SEF_EVENTS;

	    $wheres 	= array();
		switch ($phrase) {
		case 'exact':
			$wheres2 = array();

			$wheres2[] = "LOWER(p.firstname) LIKE '%$text%'";
			$wheres2[] = "LOWER(p.lastname) LIKE '%$text%'";
			$wheres2[] = "LOWER(t.short_name) LIKE '%$text%'";
			$wheres2[] = "LOWER(eventyp.name) LIKE '%$text%'";
			$where = '(' . implode( ') OR (', $wheres2 ) . ')';
			break;

		case 'all':
		case 'any':
		default:
			$words 	= explode( ' ', $text );
			$wheres = array();
			foreach ($words as $word) {
				$wheres2 = array();
		  		$wheres2[] = "LOWER(p.firstname) LIKE '%$word%'";
				$wheres2[] = "LOWER(p.lastname) LIKE '%$word%'";
				$wheres2[] = "LOWER(t.short_name) LIKE '%$word%'";
				$wheres2[] = "LOWER(eventyp.name) LIKE '%$word%'";
				$wheres[] = implode( ' OR ', $wheres2 );
			}
			$where 	= '(' . implode( ($phrase == 'all' ? ') AND 
                                   (' : ') OR ('), $wheres ) . ')';
			break;
       }
	   /* Aditional Information
		  SUM(event_sum) AS value, p.firstname, p.lastname,
                       me.player_id , pt.team_id, t.short_name as team,
                       eventyp.id, eventyp.name
          search at jos_joomleague_et_joomleague
       */
	   
	   $query = 
		 sprintf("SELECT 
		         CONCAT(  ".$database->Quote(_JL_TABLE_TEAM).",': ' ,
                       t.short_name, '&nbsp;&nbsp;&#64;&nbsp;&nbsp;' ,
                       ".$database->Quote(_JL_PAGE_TITLE_PLAYER).", ': ' ,
                       p.firstname, ' ' , p.lastname) as text,
                 CONCAT_WS( ' ', p.firstname, '&nbsp;(',
		           CONVERT(SUM(event_sum) USING utf8),')' ) as title,
 	         CONCAT(".$database->Quote($section)." 
                         ,' / ',eventyp.name) AS section,
		 CONCAT('index.php?option=com_joomleague&func=eventsStats&p=', 
                                 me.project_id ,'&evid=',eventyp.id) AS href,
                '1' AS browsernav
                      FROM #__joomleague_match_events me
                 LEFT JOIN #__joomleague_players p ON me.player_id = p.id
                 LEFT JOIN #__joomleague_playertool pt ON 
                                             me.player_id = pt.player_id AND
				             pt.project_id = me.project_id
                 LEFT JOIN #__joomleague_teams t ON pt.team_id = t.id 
                 LEFT JOIN #__joomleague_eventtypes eventyp ON 
                                                me.event_type_id = eventyp.id
				 WHERE (%s)", $where);

		if ($activeproject && 
            $project != 0) {
           $query .= sprintf(" AND pt.project_id = %d GROUP BY me.player_id;",
                              $project );
        } else {
    	   $query .= sprintf(" GROUP BY me.player_id;" );
		}
				 
		$database->setQuery( $query );
        $events = $database->loadObjectList();
		
     } else {
       //echo "<br> No hay busqueda de Equipos <br>";
       $events = array();
     }
     return array_merge( (array)$teams, (array)$players, (array)$events);
}
?>
