<?php 
/*
 * @version $Id: mod_joomleague_tab_results.php 1126 2008-06-09 05:45:04Z julienv $
 * @package Joomleague
 * @subpackage tabresults
 * @copyright Copyright (C) 2007  JoomLeague
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see _joomleague_license.txt
**********************************************
JoomLeague RESULTS TABS MODULE
Copyright (c) 2007 JoomLeague.de
**********************************************
This program is free software; you can redistribute it and/or modify 
it under the terms of the GNU General Public License as published by 
the Free Software Foundation; either version 2 of the License, or 
(at your option) any later version.

This header must not be removed. Additional contributions/changes
may be added to this header as long as no information is deleted.
**********************************************

* RESULTS TABS MODULE
*
* 2008-01-08 - Version 0.93
*
* Displays the last, current and next matches and results in 3 single tabs.
* There are some options for this module, which can be set in the 
* "Parameters" section of the module in Administration.
*

**********************************************
Get the latest version of JoomLeague at:
http://www.joomleague.de//
**********************************************
*/

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

global $mainframe, $database;

if (file_exists($mosConfig_absolute_path.'/components/com_joomleague/language/'.$mosConfig_lang.'.php')) {
  include_once($mosConfig_absolute_path.'/components/com_joomleague/language/'.$mosConfig_lang.'.php');
} 
else{
  include_once($mosConfig_absolute_path.'/components/com_joomleague/language/english.php');
}

require_once 'administrator/components/com_joomleague/joomleague.class.php';
require_once 'components/com_joomleague/js/joomleague_tabs.js.php';

  /**
   * get the games for the specified project / rounds / division
   *
   * @param object the project
   * @param int round matchcode
   * @param int division id (if 0, whole project)
   * @ordering string
   * @ordering bool display unpublished ?              
   */        
  function getResults( $project, $round = 0, $division = 0, $ordering="ASC", $unpublished = 0 )
  {    
	  /**
	   * get divisions
	   */     	  	  
	  if ($division > 0) 
    {
	    $div_for_teams = array( $division );
      $query = "SELECT id FROM #__joomleague_divisions WHERE parent_id=$division";
	    $project->_db->setquery($query);
	    $div_for_teams = array_merge( $div_for_teams, $project->_db->loadResultArray() );
	  }
    
    $result = array();
    
    if ( $round != 0 )
    {          
      // build query
      $query = " SELECT matches.*,
                        t1.short_name AS homeName,
                        t2.short_name AS awayName                
                 FROM #__joomleague_matches AS matches
                 INNER JOIN #__joomleague_rounds AS r ON r.id = matches.round_id
                 INNER JOIN #__joomleague_teams AS t1 ON t1.id = matches.matchpart1 
                 INNER JOIN #__joomleague_teams AS t2 ON t2.id = matches.matchpart2 ";
      
      if ($division > 0) {
        $query .= " INNER JOIN #__joomleague_team_joomleague AS tt1 ON ( matches.matchpart1 = tt1.team_id AND matches.project_id = tt1.project_id )
                    INNER JOIN #__joomleague_team_joomleague AS tt2 ON ( matches.matchpart2 = tt2.team_id AND matches.project_id = tt2.project_id ) ";
      }
      
      $query .= " WHERE  matches.project_id = ".$project->id
                . " AND r.matchcode = $round";
      
      if ($unpublished!=1) {
        $query .=" AND matches.published = 1 ";
      }
      
      if ($division > 0) {
        $query .= " AND ( tt1.division_id IN ( " . implode( ',', $div_for_teams ) . " ) 
                       OR tt2.division_id IN ( " . implode( ',', $div_for_teams ) . " ) )";                      
      }
      
      $query .= " ORDER BY matches.match_date $ordering, matches.match_number";
      $project->_db->setQuery($query);
      // print $project->_db->getQuery();
      $result = $project->_db->loadObjectList();
    }
    return $result;
  }
  
  function printTeam( $team_name, $isfav = false )
  {
    if ( $isfav ) {
      print '<b>' . $team_name . '</b>';
    }
    else {
      print $team_name;    
    }
  }

// stylesheet for tabs
$mainframe->addCustomHeadTag( '<link rel="stylesheet" 
          type="text/css" 
          href="'.$mosConfig_live_site.'/components/com_joomleague/css/joomleague_tabs.css" />' );

// get module parameters
$p        = intval( $params->get('project', 0) );
$show     = intval( $params->get('show', 0) );
$division = intval( $params->get('division', 0) );

// instatiate and try to load project
$project = new JoomLeague( $database );
if ( ! ( $p && $project->load($p) ) ) {
  print "No project selected";
}
else
{
  /**
   * get max round
   */    
  if ($params->get('maxround_auto') == 1)
  {
    // Query max. round if set to automatic
    $query = " SELECT MAX(matchcode)
               FROM #__joomleague_rounds
               WHERE project_id = $p ";
    $database->setQuery($query);
    $maxround = $database->loadResult();   
    //Query max. round END
  }
  else {
    $maxround = $params->get('maxround');
  }
  
  /**
   * get current project rounf
   */     
  $current_round = $project->current_round;
  
  /**
   * array of rounds to be displayed
   */   
  $rounds = array();
  if ( $current_round > 1 ) {
    $rounds[] = $current_round - 1;
  }
  $rounds[] = $current_round;
  if ( $current_round != $maxround ) {
    $rounds[] = $current_round + 1;
  }
  
  /**
   *   display project name
   */   
  if ( $show > 0 ) { 
    ?><div align="center"><b><?php echo $project->name;?></b></div><?php 
  }
  
    
  ?>  
  <script language="javascript" type="text/javascript">
  <!-- // --><![CDATA[ 
  var dhtml<?php echo $module->id; ?> = new mosDHTML();
  // ]]></script>
  
  <!-- table for switching tabs -->
  <table cellspacing="0" cellpadding="1" border="0" width="100%">
    <tr align="center">
      <?php 
      // tabs with round matchcode. Could be better to use round name instead ?
      $c = count($rounds);
      $width = floor(100/$c);
      foreach ( $rounds as $round )
      {
        ?>
        <td width="<?php echo $width;?>%" 
            id="tab<?php echo $round.$module->id; ?>" 
            class="offtab" 
            onclick="dhtml<?php echo $module->id; ?>.cycleTab(this.id)">
            <?php echo $round; ?>.<br />
            <?php echo _JL_MATCHDAY;?>
        </td>
        <?php
      }
      ?>
    </tr>
  </table>
  
  <!-- divs associated to tabs -->
  <?php 
  $JScrA="";
  foreach ( $rounds as $round )
  {
  	if ( $round != $current_round ) {
      $JScrA .= "dhtml" . $module->id . ".cycleTab('tab" . $round.$module->id . "');\n";
    }
    // get games
    $matches = getResults( $project, $round, $division );
    
    ?>
    <div id="page<?php echo $round.$module->id; ?>" 
         class="pagetext">
      <table cellspacing="1" cellpadding="1" border="0" width="100%">
        <?php
				$favteams = explode( ",", $project->fav_team );
        $k = 0;
        foreach ( $matches as $match )
        {
          $class = ($k == 0)? 'sectiontableentry1' : 'sectiontableentry2';
          
          // score
					if ( is_null( $match->matchpart1_result ) ) 
          {
            $goals1 = "-";
            $goals2 = "-";
          }
          else 
          {
            $goals1 = $match->matchpart1_result;
            $goals2 = $match->matchpart2_result;
          }
          
		      if ( $match->match_result_type == "1" ) {
            $mrt = 'bgcolor="#00E3FF"';
          }
          else if ( $match->match_result_type == "2" ) {
            $mrt = 'bgcolor="#FFDF00"';
          }
          ?>
          <tr class="<?php print $class;?>">
            <td align="right">
              <?php 
              printTeam( $match->homeName, in_array( $match->matchpart1, $favteams ) ); 
              ?>
            </td>
            <td>-</td>
            <td align="left">
              <?php 
              printTeam( $match->awayName, in_array( $match->matchpart2, $favteams ) ); 
              ?>
            </td>
            <td align="center" <?php print $mrt;?>>
              <?php 
              echo sprintf("%s:%s",$goals1,$goals2);
              ?>
            </td>
          </tr>
          <?php
          $k = 1 - $k;
        }
        ?>
      </table>
    </div>
    <?php
  }
  ?>
  
  <script language="javascript" type="text/javascript">
  <?php
  echo $JScrA;
  echo "dhtml".$module->id.".cycleTab('tab".$current_round.$module->id."');\n";
  ?>
  </script>
  <?php
}
?>
